function [tarray zarray] = rk2(rhs, tspan,z0,n,p)
%Euler integrator
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tarray = linspace(tspan(1),tspan(2),n+1); % initialize tarray
h      = tarray(2)-tarray(1); %size of time step
zarray = zeros(n+1,length(z0)); zarray(1,:) = z0'; % initialize zarray

 for i=1:n;
    z = zarray(i,:)';  t = tarray(i);
    ztemp =  z +   h/2  *feval(rhs,t,z,p);     %Tke half a step
    znew  =  z +   h    *feval(rhs,t,ztemp,p); %THE KEY LINE!!
    zarray(i+1,:) = znew';
 end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
